# n24.tcl v1.0 by domsen <domsen@domsen.org> (c)2oo4
#
# comments? bugs? ideas? requests? money? beer? 
# plz mail me or visit my homepage @ www.domsen.org
# visit #newsticker@ircnet
#
# das tcl  liest  die www.n24.de  news aus  und gibt  sie wieder,  gleich mit
# dem link zum eigentlichen artikel. per trigger lassen sich auch die letzten X
# news von hand auslesen.
#
# v1.0 - first public release
#
# n24trigger - der trigger auf den der bot reagiert (public und message)
# n24limit - maximum der news die auf befehl geposted werden
# n24newspost  - 1 fr newsposting, 0 fr keines
# n24chans  - die  chans in  denen das tcl aktiv  ist, "" fr alle
# n24newspostlimit - maximum der news die geposted werden
# isn24hub  - legt fest ob der bot newshub ist oder nicht
# n24leafs  - die nicks der leafbots auf denen das leaf tcl luft
#
####### config ######################

set n24trigger ".n24"
set n24chans ""
set n24limit "10"
set n24newspostlimit "3"
set n24newspost "1"
set isn24hub "0"
set n24leafs ""

####### ende der config #############

bind msg - $n24trigger msg_n24
bind pub - $n24trigger pub_n24
bind time - "?0 * * * *" n24check

proc sendn24news { arg } {
global n24leafs
foreach bot [bots] {
if {([lsearch -exact [string tolower $n24leafs] [string tolower $bot]] != -1)} {
putbot $bot "n24: $arg"
}}}

proc shrink { calc number string start bl} { return [expr [string first "$string" $bl $start] $calc $number] }


proc html { text } {
regsub -all "&uuml;" $text "" text
regsub -all "&ouml;" $text "" text
regsub -all "&auml;" $text "" text
regsub -all "&Uuml;" $text "" text
regsub -all "&Ouml;" $text "" text
regsub -all "&Auml;" $text "" text
regsub -all "&szlig;" $text "" text
regsub -all "&quot;" $text "\"" text
regsub -all "&amp;" $text "&" text
regsub -all "<sub>" $text "" text
regsub -all "&lt;" $text "<" text
regsub -all "&gt;" $text ">" text
return $text
}


proc n24check {nick uhost hand chan arg} {
global n24chans n24newspost isn24hub n24newspostlimit
set counter 0
if {$n24newspost == 1 } {
putlog "n24: suche nach neuer newsline"
set n24lastnews "none"
if {[file exists n24.hdl]} {
set temp [open "n24.hdl" r]
set n24lastnews "[gets $temp]"
if {$n24lastnews == ""} { set n24lastnews "none" }
close $temp
}
set temp [open "n24.hdl" w+]
if {[catch {set sock [socket www.n24.de 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /rss/ HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: www.n24.de"
puts $sock ""
flush $sock
set counter 0
while {[eof $sock] != 1} {
set bl [gets $sock]

if {[string first "<title>" $bl] != -1 && [string first "Werden Sie Augenzeuge" $bl] == -1 } { set newsline [string range $bl 9 [shrink - 1 "</" 0 $bl]]}
if {[string first "<link>" $bl] != -1 && [string first "home</link" $bl] == -1} { set link [string range $bl 8 [shrink - 1 </ 0 $bl]]
puts $temp "[html $newsline] <$link>"
}}}
close $sock ; close $temp
if {$n24lastnews == "none" } { putlog "n24: headlinefile created" ; return 0 }
set temp [open "n24.hdl" r]
while { [eof $temp] != 1 } {
set n24neunews [gets $temp]
if {($n24lastnews == $n24neunews) || ($counter == $n24newspostlimit)} { close $temp;return 0 }
incr counter
foreach chan [channels] {
if {$n24chans == "" } { putserv "privmsg $chan :(neue n24 newsline) $n24neunews" }
if {$n24chans != "" } {
if {([lsearch -exact [string tolower $n24chans] [string tolower $chan]] != -1) || ($n24chans == "")} {putserv "privmsg $chan :(neue n24 newsline) $n24neunews"}
}
if { $isn24hub == "1" } { sendn24news $n24neunews }
}}}}


proc n24news {target limit} {
if {[catch {set sock [socket www.n24.de 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /rss/ HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: www.n24.de"
puts $sock ""
flush $sock
set counter 0
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "<title>" $bl] != -1 && [string first "Werden Sie Augenzeuge" $bl] == -1 } { set newsline [string range $bl 9 [shrink - 1 "</" 0 $bl]]}
if {[string first "<link>" $bl] != -1 && [string first "home</link" $bl] == -1} { set link [string range $bl 8 [shrink - 1 </ 0 $bl]]
putserv "privmsg $target :[incr counter] [html $newsline] <$link>"
}
if {$counter == $limit} {close $sock ; return 0 }
}}}

proc msg_n24 { nick uhost hand arg } { global n24limit ; n24news $nick $n24limit }
proc pub_n24 { nick uhost hand chan arg } { global n24chans n24limit ; if {([lsearch -exact [string tolower $n24chans] [string tolower $chan]] != -1) || ($n24chans == "")} { n24news $nick $n24limit }}

putlog "*** n24.tcl v1.0 by domsen <domsen@domsen.org> succesfully loaded"

#[EOF]